%define nginx_user nginx
%define nginx_group nginx
%define epoch 1
%define __arch_install_post   /usr/lib/rpm/check-rpaths   /usr/lib/rpm/check-buildroot

%if 0%{?rhel} || 0%{?amzn} || 0%{?fedora}
%define _group System Environment/Daemons
%if 0%{?amzn} == 2
BuildRequires: openssl11-devel
%else
BuildRequires: openssl-devel
%endif
%endif

%if 0%{?suse_version} >= 1315
%define _group Productivity/Networking/Web/Servers
BuildRequires: libopenssl-devel
%define _debugsource_template %{nil}
%endif

%if (0%{?el7}) && (0%{?amzn} == 0)
Epoch: %{epoch}
%define dist .el7
%endif

%if (0%{?el7}) && (0%{?amzn} == 2)
Epoch: %{epoch}
%endif

%if 0%{?el8}
Epoch: %{epoch}
%define _debugsource_template %{nil}
%endif

%if 0%{?el9}
Epoch: %{epoch}
%define _debugsource_template %{nil}
%endif

%if 0%{?fedora}
%define _debugsource_template %{nil}
%global _hardened_build 1
%endif

%define base_version 1.27.3
%define base_release 1%{?dist}

%define bdir %{_builddir}/%{name}-%{base_version}

Summary: nginx njs dynamic modules
Name: nginx-module-njs
Version: 1.27.3+0.8.7
Release: 1%{?dist}
Packager: Teddysun <i@teddysun.com>
URL: https://nginx.org/
Group: %{_group}

Source0: https://nginx.org/download/nginx-%{base_version}.tar.gz
Source1: nginx-module-njs.copyright
Source100: njs-0.8.7.tar.gz
Source101: quickjs-2024.07.24.tar.xz

Patch100: quickjs_quickjs.makefile.patch

License: 2-clause BSD-like license

BuildRoot: %{_tmppath}/%{name}-%{base_version}-%{base_release}-root
BuildRequires: zlib-devel
BuildRequires: pcre2-devel
BuildRequires: libedit-devel
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel
BuildRequires: which
%if ((0%{?rhel} >= 8) || (0%{?amzn} >= 2023))
BuildRequires: libatomic
%endif
Requires: nginx-%{epoch}:%{base_version}
Provides: %{name}-%{base_version}

%description
nginx njs dynamic modules.

%if 0%{?suse_version}
%debug_package
%endif

%define WITH_CC_OPT $(echo %{optflags} $(pcre2-config --cflags))
%define WITH_LD_OPT -Wl,-z,relro -Wl,-z,now -Wl,-as-needed

%define BASE_CONFIGURE_ARGS $(echo "--prefix=%{_sysconfdir}/nginx --sbin-path=%{_sbindir}/nginx --modules-path=%{_libdir}/nginx/modules --conf-path=%{_sysconfdir}/nginx/nginx.conf --error-log-path=%{_localstatedir}/log/nginx/error.log --http-log-path=%{_localstatedir}/log/nginx/access.log --pid-path=%{_localstatedir}/run/nginx.pid --lock-path=%{_localstatedir}/run/nginx.lock --http-client-body-temp-path=%{_localstatedir}/cache/nginx/client_temp --http-proxy-temp-path=%{_localstatedir}/cache/nginx/proxy_temp --http-fastcgi-temp-path=%{_localstatedir}/cache/nginx/fastcgi_temp --http-uwsgi-temp-path=%{_localstatedir}/cache/nginx/uwsgi_temp --http-scgi-temp-path=%{_localstatedir}/cache/nginx/scgi_temp --user=%{nginx_user} --group=%{nginx_group} --with-compat --with-file-aio --with-threads --with-http_addition_module --with-http_auth_request_module --with-http_dav_module --with-http_flv_module --with-http_gunzip_module --with-http_gzip_static_module --with-http_mp4_module --with-http_random_index_module --with-http_realip_module --with-http_secure_link_module --with-http_slice_module --with-http_ssl_module --with-http_stub_status_module --with-http_sub_module --with-http_v2_module $( if [ 0%{?rhel} -eq 7 ] || [ 0%{?suse_version} -eq 1315 ]; then continue; else echo "--with-http_v3_module"; fi; ) --with-mail --with-mail_ssl_module --with-stream --with-stream_realip_module --with-stream_ssl_module --with-stream_ssl_preread_module")
%define MODULE_CONFIGURE_ARGS $(echo "--add-dynamic-module=njs-0.8.7/nginx")

%prep
%setup -qcTn %{name}-%{base_version}
tar --strip-components=1 -zxf %{SOURCE0}

ln -s . nginx%{?base_suffix}


tar xvzfo %{SOURCE100}
ln -s njs-* njs
tar xvJfo %{SOURCE101}
ln -s quickjs-* quickjs

cd %{bdir}/quickjs
%patch100 -p1

%build

_nproc=`getconf _NPROCESSORS_ONLN`
if [ $_nproc -gt 1 ]; then
    _make_opts="-j$_nproc"
fi

%define __with_quickjs %{nil}
%if (0%{?rhel} >= 8) || (0%{?amzn} >= 2023) || (0%{?suse_version} >= 1500)
cd %{bdir}/quickjs-2024.07.24 && CFLAGS="%{WITH_CC_OPT} -fPIC" make $_make_opts libquickjs.a
%define __with_quickjs --with-quickjs
%endif
cd %{bdir}/njs-0.8.7 && sed -i.bak 's,-lquickjs.lto ,-lquickjs.lto -latomic ,g' auto/quickjs && sed -i.bak 's,-lquickjs ,-lquickjs -latomic ,g' auto/quickjs && ./configure %{__with_quickjs} --cc-opt="%{WITH_CC_OPT} -I%{bdir}/quickjs-2024.07.24/" --ld-opt="%{WITH_LD_OPT} -L%{bdir}/quickjs-2024.07.24/" && make $_make_opts njs && mv build build-cli
cd %{bdir}

./configure %{BASE_CONFIGURE_ARGS} %{MODULE_CONFIGURE_ARGS} \
	--with-cc-opt="%{WITH_CC_OPT} -I%{bdir}/quickjs-2024.07.24/" \
	--with-ld-opt="%{WITH_LD_OPT} -L%{bdir}/quickjs-2024.07.24/" \
	--with-debug
make %{?_smp_mflags} modules
for so in `find %{bdir}/objs/ -type f -name "*.so"`; do
debugso=`echo $so | sed -e 's|\.so$|-debug.so|'`
mv $so $debugso
done

./configure %{BASE_CONFIGURE_ARGS} %{MODULE_CONFIGURE_ARGS} \
	--with-cc-opt="%{WITH_CC_OPT} -I%{bdir}/quickjs-2024.07.24/" \
	--with-ld-opt="%{WITH_LD_OPT} -L%{bdir}/quickjs-2024.07.24/"
make %{?_smp_mflags} modules

%install
cd %{bdir}
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}%{_datadir}/doc/nginx-module-njs
%{__install} -m 644 -p %{SOURCE1} %{buildroot}%{_datadir}/doc/nginx-module-njs/COPYRIGHT

%{__install} -m644 %{bdir}/njs-0.8.7/CHANGES %{buildroot}%{_datadir}/doc/%{name}/
%{__mkdir} -p %{buildroot}%{_bindir}
%{__install} -m755 %{bdir}/njs-0.8.7/build-cli/njs %{buildroot}%{_bindir}/

%{__mkdir} -p %{buildroot}%{_libdir}/nginx/modules
for so in `find %{bdir}/objs/ -maxdepth 1 -type f -name "*.so"`; do
%{__install} -m755 $so %{buildroot}%{_libdir}/nginx/modules/
done

%check
%{__rm} -rf %{buildroot}/usr/src
cd %{bdir}
grep -v 'usr/src' debugfiles.list > debugfiles.list.new && mv debugfiles.list.new debugfiles.list
cat /dev/null > debugsources.list
%if 0%{?suse_version} >= 1500
cat /dev/null > debugsourcefiles.list
%endif

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%{_libdir}/nginx/modules/*
%dir %{_datadir}/doc/nginx-module-njs
%{_datadir}/doc/nginx-module-njs/*
%{_bindir}/njs

%post
if [ $1 -eq 1 ]; then
cat <<BANNER
----------------------------------------------------------------------

The njs dynamic modules for nginx have been installed.
To enable these modules, add the following to /etc/nginx/nginx.conf
and reload nginx:

    load_module modules/ngx_http_js_module.so;
    load_module modules/ngx_stream_js_module.so;

Please refer to the modules documentation for further details:
https://nginx.org/en/docs/njs/
https://nginx.org/en/docs/http/ngx_http_js_module.html
https://nginx.org/en/docs/stream/ngx_stream_js_module.html

----------------------------------------------------------------------
BANNER
fi

%changelog
* Fri Nov 29 2024 Teddysun <i@teddysun.com> - 1.27.3-1
- Update to 1.27.3
- Update njs to 0.8.7

* Thu Oct 03 2024 Teddysun <i@teddysun.com> - 1.27.2-1
- Update to 1.27.2
- Update njs to 0.8.6
